Argus Camera Sample Argus Camera Sample

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
IAppModule.h
Go to the documentation of this file.
1 /*
2 * Copyright (c) 2016, NVIDIA CORPORATION. All rights reserved.
3 *
4 * Redistribution and use in source and binary forms, with or without
5 * modification, are permitted provided that the following conditions
6 * are met:
7 * * Redistributions of source code must retain the above copyright
8 * notice, this list of conditions and the following disclaimer.
9 * * Redistributions in binary form must reproduce the above copyright
10 * notice, this list of conditions and the following disclaimer in the
11 * documentation and/or other materials provided with the distribution.
12 * * Neither the name of NVIDIA CORPORATION nor the names of its
13 * contributors may be used to endorse or promote products derived
14 * from this software without specific prior written permission.
15 *
16 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
17 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
20 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
23 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
24 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
25 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
26 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
27 */
28
29 #ifndef ARGUS_APPS_CAMERA_UI_COMMON_APP_MODULE_H
30 #define ARGUS_APPS_CAMERA_UI_COMMON_APP_MODULE_H
31
32 #include "Window.h"
33
34 namespace ArgusSamples
35 {
36
37 class Options;
38
39 /**
40 * A application module exposes command line options, GUI elements and executes tasks.
41 */
42 class IAppModule
43 {
44 public:
45 IAppModule() { }
46 virtual ~IAppModule() { };
47
48 /**
49 * Initialize
50 *
51 * @param [in] options each app module can add options
52 */
53 virtual bool initialize(Options &options) = 0;
54
55 /**
56 * Shut down
57 */
58 virtual bool shutdown() = 0;
59
60 /**
61 * Start the module
62 *
63 * @param [in] iGuiMenuBar optional, the module can add menu items to this menu bar
64 * @param [in] iGuiContainerConfig optional, the module can add configuration options to this
65 * container
66 */
67 virtual bool start(Window::IGuiMenuBar *iGuiMenuBar = NULL,
68 Window::IGuiContainer *iGuiContainerConfig = NULL) = 0;
69
70 /**
71 * Stop the module
72 */
73 virtual bool stop() = 0;
74 };
75
76 }; // namespace ArgusSamples
77
78 #endif // ARGUS_APPS_CAMERA_UI_COMMON_APP_MODULE_H